blob: a1e0921574d076b8d87d670c56162a5ce44c0e7d [file] [log] [blame]
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001#!/bin/bash
2
3. ../common/test_env.sh
4
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00005
6
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00007echo "Test case started as: ${BASH_SOURCE[$i+1]} "$1 $2
8
9# Script containing all functions needed for auto testing of test cases
10# Arg: local [<image-tag>] ]| remote [<image-tag>] ]| remote-remove [<image-tag>]] | manual-container | manual-app
11
BjornMagnussonXAa79a0432019-07-17 08:26:50 +000012STARTED_DFCS="" #DFC app names added to this var to keep track of started container in the script
BjornMagnussonXA42dcb262019-04-26 19:29:54 +000013START_ARG=$1
14IMAGE_TAG="latest"
15
16if [ $# -gt 1 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +000017 if [[ "$2" =~ ^1.1.* ]]; then
18 echo "This version of auto-test does not support DFC image version of 1.1.X"
19 exit 1
20 fi
BjornMagnussonXA42dcb262019-04-26 19:29:54 +000021 IMAGE_TAG=$2
22fi
23
24if [ $# -lt 1 ] || [ $# -gt 2 ]; then
25 echo "Expected arg: local [<image-tag>] ]| remote [<image-tag>] ]| remote-remove [<image-tag>]] | manual-container | manual-app"
26 exit 1
27elif [ $1 == "local" ]; then
28 if [ -z $DFC_LOCAL_IMAGE ]; then
29 echo "DFC_LOCAL_IMAGE not set in test_env"
30 exit 1
31 fi
32 DFC_IMAGE=$DFC_LOCAL_IMAGE":"$IMAGE_TAG
33elif [ $1 == "remote" ] || [ $1 == "remote-remove" ]; then
34 if [ -z $DFC_REMOTE_IMAGE ]; then
35 echo "DFC_REMOTE_IMAGE not set in test_env"
36 exit 1
37 fi
38 DFC_IMAGE=$DFC_REMOTE_IMAGE":"$IMAGE_TAG
39elif [ $1 == "manual-container" ] && [ $# -eq 1 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +000040 echo "DFC is expected to be started manually, when prompted, as a container with name 'dfc_app'<index> with and index in the range from 0 to '${DFC_MAX_IDX}'"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +000041elif [ $1 == "manual-app" ] && [ $# -eq 1 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +000042 echo "DFC is expected to be started manually, when prompted, as a java application"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +000043else
44 echo "Expected arg: local [<image-tag>] ]| remote [<image-tag>] ]| remote-remove [<image-tag>]] | manual-container | manual-app"
45 exit 1
46fi
47
48# Set a description string for the test case
49if [ -z "$TC_ONELINE_DESCR" ]; then
50 TC_ONELINE_DESCR="<no-description>"
51 echo "No test case description found, TC_ONELINE_DESCR should be set on in the test script , using "$TC_ONELINE_DESCR
52fi
53
54# Counter for test suites
55if [ -f .tmp_tcsuite_ctr ]; then
56 tmpval=$(< .tmp_tcsuite_ctr)
57 ((tmpval++))
58 echo $tmpval > .tmp_tcsuite_ctr
59fi
60
61# Create a test case id, ATC (Auto Test Case), from the name of the test case script.
62# FTC1.sh -> ATC == FTC1
63ATC=$(basename "${BASH_SOURCE[$i+1]}" .sh)
64
65# Create the logs dir if not already created in the current dir
66if [ ! -d "logs" ]; then
67 mkdir logs
68fi
69
70TESTLOGS=$PWD/logs
71
72# Create a log dir for the test case
ecaiyanlinux796e8fe2019-08-21 12:10:33 +000073mkdir -p $TESTLOGS/$ATC
BjornMagnussonXA42dcb262019-04-26 19:29:54 +000074
75# Clear the log dir for the test case
76rm $TESTLOGS/$ATC/*.log &> /dev/null
77
78# Log all output from the test case to a TC log
79TCLOG=$TESTLOGS/$ATC/TC.log
80exec &> >(tee ${TCLOG})
81
82#Variables for counting tests as well as passed and failed tests
83RES_TEST=0
84RES_PASS=0
85RES_FAIL=0
86TCTEST_START=$SECONDS
87
88echo "-------------------------------------------------------------------------------------------------"
89echo "----------------------------------- Test case: "$ATC
90echo "----------------------------------- Started: "$(date)
91echo "-------------------------------------------------------------------------------------------------"
92echo "-- Description: "$TC_ONELINE_DESCR
93echo "-------------------------------------------------------------------------------------------------"
94echo "----------------------------------- Test case setup -----------------------------------"
95
96if [ -z "$SIM_GROUP" ]; then
97 SIM_GROUP=$PWD/../simulator-group
98 if [ ! -d $SIM_GROUP ]; then
99 echo "Trying to set env var SIM_GROUP to dir 'simulator-group' in the integration repo, but failed."
100 echo "Please set the SIM_GROUP manually in the test_env.sh"
101 exit 1
ecaiyanlinux796e8fe2019-08-21 12:10:33 +0000102 else
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000103 echo "SIM_GROUP auto set to: " $SIM_GROUP
104 fi
105elif [ $SIM_GROUP = *simulator_group ]; then
106 echo "Env var SIM_GROUP does not seem to point to dir 'simulator-group' in the integration repo, check test_env.sh"
107 exit 1
108fi
109
110echo ""
111
112if [ $1 != "manual-container" ] && [ $1 != "manual-app" ]; then
113 echo -e "DFC image tag set to: \033[1m" $IMAGE_TAG"\033[0m"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000114 echo "Configured image for DFC app(s) (${1}): "$DFC_IMAGE
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000115 tmp_im=$(docker images ${DFC_IMAGE} | grep -v REPOSITORY)
116
117 if [ $1 == "local" ]; then
118 if [ -z "$tmp_im" ]; then
119 echo "Local image (non nexus) "$DFC_IMAGE" does not exist in local registry, need to be built"
120 exit 1
121 else
122 echo -e "DFC local image: \033[1m"$tmp_im"\033[0m"
123 echo "If the DFC image seem outdated, rebuild the image and run the test again."
124 fi
125 elif [ $1 == "remote" ] || [ $1 == "remote-remove" ]; then
126
127 if [ $1 == "remote-remove" ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000128 echo "Attempt to stop dfc_app container(s) if running"
129 docker stop $(docker ps -q --filter name=${DFC_APP_BASE}]) &> /dev/null
130 docker rm $(docker ps -q --filter name=${DFC_APP_BASE}) &> /dev/null
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000131 docker rmi $DFC_IMAGE &> /dev/null
132 tmp_im=""
133 fi
134 if [ -z "$tmp_im" ]; then
135 echo "Pulling DFC image from nexus: "$DFC_IMAGE
136 docker pull $DFC_IMAGE > /dev/null
137 tmp_im=$(docker images ${DFC_IMAGE} | grep -v REPOSITORY)
138 if [ -z "$tmp_im" ]; then
139 echo "Image could not be pulled"
140 exit 1
141 fi
142 echo -e "DFC image: \033[1m"$tmp_im"\033[0m"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000143 else
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000144 echo -e "DFC image: \033[1m"$tmp_im"\033[0m"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000145 echo "!! If the dfc image seem outdated, consider removing it from your docker registry and run the test again. Or run the script with 'remote-remove'"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000146 fi
147 fi
148fi
149
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000150
151
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000152echo ""
153
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000154echo "Building images for the simulators if needed, MR, DR, DR Redir and FTPS simulators"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000155curdir=$PWD
156cd $SIM_GROUP
157cd ../dr-sim
158docker build -t drsim_common:latest . &> /dev/null
159cd ../mr-sim
160docker build -t mrsim:latest . &> /dev/null
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000161cd ../ftps-sftp-server
162docker build -t ftps_vsftpd:latest -f Dockerfile-ftps . &> /dev/null
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000163cd $curdir
164
165echo ""
166
167echo "Local registry images for simulators:"
168echo "MR simulator " $(docker images | grep mrsim)
169echo "DR simulator: " $(docker images | grep drsim_common)
170echo "DR redir simulator: " $(docker images | grep drsim_common)
171echo "SFTP: " $(docker images | grep atmoz/sftp)
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000172echo "FTPS: " $(docker images | grep ftps_vsftpd)
173echo "Consul: " $(docker images | grep consul)
174echo "CBS: " $(docker images | grep platform.configbinding.app)
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000175echo ""
176
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000177#Configure MR sim to use correct host:port for running dfc as an app or as a container
178#Configure DR sim with correct address for DR redirect simulator
179if [ $START_ARG == "manual-app" ]; then
180 export SFTP_SIMS=$SFTP_SIMS_LOCALHOST
181 export FTPS_SIMS=$FTPS_SIMS_LOCALHOST
182 export DR_REDIR_SIM="localhost"
183fi
184#else
185# export SFTP_SIMS=$SFTP_SIMS_CONTAINER
186# export FTPS_SIMS=$FTPS_SIMS_CONTAINER
187# export DR_REDIR_SIM="drsim_redir"
188#fi
189
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000190echo "----------------------------------- Test case steps -----------------------------------"
191
192# Print error info for the call in the parent script (test case). Arg: <error-message-to-print>
193# Not to be called from test script.
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000194__print_err() {
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000195 echo ${FUNCNAME[1]} " "$1" " ${BASH_SOURCE[$i+2]} " line" ${BASH_LINENO[$i+1]}
196}
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000197# Execute curl using the host and variable. Arg: <host and variable-name> [ <flag-to-strip-new-line> ]
198#<flag-to-strip-new-line> may contain any string, it is just a flag
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000199# Returns the variable value (if success) and return code 0 or an error message and return code 1
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000200__do_curl() {
ecaiyanlinux796e8fe2019-08-21 12:10:33 +0000201 res=$(curl -skw "%{http_code}" $1)
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000202 http_code="${res:${#res}-3}"
203 if [ ${#res} -eq 3 ]; then
204 echo "<no-response-from-server>"
205 return 1
206 else
207 if [ $http_code -lt 200 ] && [ $http_code -gt 299]; then
208 echo "<not found, resp:${http_code}>"
209 return 1
210 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000211 if [ $# -eq 2 ]; then
212 echo "${res:0:${#res}-3}" | xargs
213 else
214 echo "${res:0:${#res}-3}"
215 fi
216
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000217 return 0
218 fi
219}
220
221# Test a simulator variable value towards target value using an condition operator with an optional timeout.
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000222# Arg: <simulator-name> <host> <variable-name> <condition-operator> <target-value> - This test is done
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000223# immediately and sets pass or fail depending on the result of comparing variable and target using the operator.
224# Arg: <simulator-name> <host> <variable-name> <condition-operator> <target-value> <timeout> - This test waits up to the timeout
225# before setting pass or fail depending on the result of comparing variable and target using the operator.
226# Not to be called from test script.
227
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000228__var_test() {
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000229 if [ $# -eq 6 ]; then
230 echo -e "---- ${1} sim test criteria: \033[1m ${3} \033[0m ${4} ${5} within ${6} seconds ----"
231 ((RES_TEST++))
232 start=$SECONDS
233 ctr=0
234 for (( ; ; ))
235 do
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000236 result="$(__do_curl $2$3)"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000237 retcode=$?
238 result=${result//[[:blank:]]/} #Strip blanks
239 duration=$((SECONDS-start))
240 if [ $((ctr%30)) -eq 0 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000241 echo " Result=${result} after ${duration} seconds"
242 for (( i=0; i<=$DFC_MAX_IDX; i++ )); do
243 if [[ $STARTED_DFCS =~ "_"$DFC_APP_BASE$i"_" ]]; then
244 echo " HB ${DFC_APP_BASE}${i}: $(__do_curl http://127.0.0.1:$(($DFC_PORT+$i))/status strip)"
245 fi
246 done
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000247 else
248 echo -ne " Result=${result} after ${duration} seconds\033[0K\r"
249 fi
250 let ctr=ctr+1
251 if [ $retcode -ne 0 ]; then
252 if [ $duration -gt $6 ]; then
253 ((RES_FAIL++))
254 echo -e "---- \033[31m\033[1mFAIL\033[0m - Target ${3} ${4} ${5} not reached in ${6} seconds, result = ${result} ----"
255 return
256 fi
257 elif [ $4 = "=" ] && [ "$result" -eq $5 ]; then
258 ((RES_PASS++))
259 echo -e " Result=${result} after ${duration} seconds\033[0K\r"
260 echo -e "---- \033[32m\033[1mPASS\033[0m - Test criteria met in ${duration} seconds ----"
261 return
262 elif [ $4 = ">" ] && [ "$result" -gt $5 ]; then
263 ((RES_PASS++))
264 echo -e " Result=${result} after ${duration} seconds\033[0K\r"
265 echo -e "---- \033[32m\033[1mPASS\033[0m - Test criteria met in ${duration} seconds, result = ${result} ----"
266 return
267 elif [ $4 = "<" ] && [ "$result" -lt $5 ]; then
268 ((RES_PASS++))
269 echo -e " Result=${result} after ${duration} seconds\033[0K\r"
270 echo -e "---- \033[32m\033[1mPASS\033[0m - Test criteria met in ${duration} seconds, result = ${result} ----"
271 return
272 elif [ $4 = "contain_str" ] && [[ $result =~ $5 ]]; then
273 ((RES_PASS++))
274 echo -e " Result=${result} after ${duration} seconds\033[0K\r"
275 echo -e "---- \033[32m\033[1mPASS\033[0m - Test criteria met in ${duration} seconds, result = ${result} ----"
276 return
277 else
278 if [ $duration -gt $6 ]; then
279 ((RES_FAIL++))
280 echo -e "---- \033[31m\033[1mFAIL\033[0m - Target ${3} ${4} ${5} not reached in ${6} seconds, result = ${result} ----"
281 return
282 fi
283 fi
284 sleep 1
285 done
286 elif [ $# -eq 5 ]; then
287 echo -e "---- ${1} sim test criteria: \033[1m ${3} \033[0m ${4} ${5} ----"
288 ((RES_TEST++))
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000289 result="$(__do_curl $2$3)"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000290 retcode=$?
291 result=${result//[[:blank:]]/} #Strip blanks
292 if [ $retcode -ne 0 ]; then
293 ((RES_FAIL++))
294 echo -e "---- \033[31m\033[1mFAIL\033[0m - Target ${3} ${4} ${5} not reached, result = ${result} ----"
295 elif [ $4 = "=" ] && [ "$result" -eq $5 ]; then
296 ((RES_PASS++))
297 echo -e "---- \033[32m\033[1mPASS\033[0m - Test criteria met"
298 elif [ $4 = ">" ] && [ "$result" -gt $5 ]; then
299 ((RES_PASS++))
300 echo -e "---- \033[32m\033[1mPASS\033[0m - Test criteria met, result = ${result} ----"
301 elif [ $4 = "<" ] && [ "$result" -lt $5 ]; then
302 ((RES_PASS++))
303 echo -e "---- \033[32m\033[1mPASS\033[0m - Test criteria met, result = ${result} ----"
304 elif [ $4 = "contain_str" ] && [[ $result =~ $5 ]]; then
305 ((RES_PASS++))
306 echo -e "---- \033[32m\033[1mPASS\033[0m - Test criteria met, result = ${result} ----"
307 else
308 ((RES_FAIL++))
309 echo -e "---- \033[31m\033[1mFAIL\033[0m - Target ${3} ${4} ${5} not reached, result = ${result} ----"
310 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000311 else
312 echo "Wrong args to __var_test, needs five or six args: <simulator-name> <host> <variable-name> <condition-operator> <target-value> [ <timeout> ]"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000313 exit 1
314 fi
315}
316# Stops a named container
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000317__docker_stop() {
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000318 if [ $# -ne 1 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000319 echo "__docker_stop need 1 arg <container-name>"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000320 exit 1
321 fi
322 tmp=$(docker stop $1 2>/dev/null)
323 if [ -z $tmp ] || [ $tmp != $1 ]; then
324 echo " ${1} container not stopped or not existing"
325 else
326 echo " ${1} container stopped"
327 fi
328}
329
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000330# Starts a named container (that has previously been stopped)
331__docker_start() {
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000332 if [ $# -ne 1 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000333 echo "__docker_start need 1 arg <container-name>"
334 exit 1
335 fi
336 tmp=$(docker start $1 2>/dev/null)
337 if [ -z $tmp ] || [ $tmp != $1 ]; then
338 echo " ${1} container not started or not existing"
339 else
340 echo " ${1} container started"
341 fi
342}
343
344# Removes a named container
345__docker_rm() {
346 if [ $# -ne 1 ]; then
347 echo "__docker_rm need 1 arg <container-name>"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000348 exit 1
349 fi
350 tmp=$(docker rm $1 2>/dev/null)
351 if [ -z $tmp ] || [ $tmp != $1 ]; then
352 echo " ${1} container not removed or not existing"
353 else
354 echo " ${1} container removed"
355 fi
356}
357
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000358__start_dfc_image() {
ecaiyanlinuxec8c60c2019-08-30 13:39:30 +0000359 set -x
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000360 if [ $# != 2 ]; then
361 __print_err "need tow args, <dfc-instance-name> 0.."$$DFC_MAX_IDX
362 exit 1
363 fi
364
365 if [ $2 -lt 0 ] || [ $2 -gt $DFC_MAX_IDX ]; then
366 __print_err "need two args, <dfc-instance-name> 0.."$DFC_MAX_IDX
367 exit 1
368 fi
369 appname=$1
370 localport=$(($DFC_PORT + $2))
371 localport_secure=$(($DFC_PORT_SECURE + $2))
372
373 echo "Creating docker network $DOCKER_SIM_NWNAME, if needed"
374
375 docker network ls| grep $DOCKER_SIM_NWNAME > /dev/null || docker network create $DOCKER_SIM_NWNAME
376
377 echo "Starting DFC: " $appname " with ports mapped to " $localport " and " $localport_secure " in docker network "$DOCKER_SIM_NWNAME
ecaiyanlinuxec8c60c2019-08-30 13:39:30 +0000378 docker run -d --volume $(pwd)/../simulator-group/tls/:/opt/app/datafile/etc/cert/ -p $localport":8100" -p $localport_secure":8433" --network=$DOCKER_SIM_NWNAME -e CONSUL_HOST=$CONSUL_HOST -e CONSUL_PORT=$CONSUL_PORT -e CONFIG_BINDING_SERVICE=$CONFIG_BINDING_SERVICE -e HOSTNAME=$appname --name $appname $DFC_IMAGE
379 sleep 3
380 set +x
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000381 dfc_started=false
382 for i in {1..10}; do
ecaiyanlinuxec8c60c2019-08-30 13:39:30 +0000383 if [ $(docker inspect --format '{{ .State.Running }}' $appname) ]
384 then
385 echo " Image: $(docker inspect --format '{{ .Config.Image }}' ${appname})"
386 echo "DFC container ${appname} running"
387 dfc_started=true
388 break
389 else
390 sleep $i
391 fi
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000392 done
393 if ! [ $dfc_started ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000394 echo "DFC container ${appname} could not be started"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000395 exit 1
396 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000397
398 dfc_hb=false
399 echo "Waiting for DFC ${appname} heartbeat..."
400 for i in {1..10}; do
401 result="$(__do_curl http://127.0.0.1:${localport}/heartbeat)"
402 if [ $? -eq 0 ]; then
403 echo "DFC ${appname} responds to heartbeat: " $result
404 dfc_hb=true
405 result="$(__do_curl http://127.0.0.1:${localport}/actuator/info)"
406 echo "DFC ${appname} image build info: " $result
407 break
408 else
409 sleep $i
410 fi
411 done
412
ecaiyanlinuxec8c60c2019-08-30 13:39:30 +0000413 if [ "$dfc_hb" = "false" ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000414 echo "DFC ${appname} did not respond to heartbeat"
ecaiyanlinuxec8c60c2019-08-30 13:39:30 +0000415 exit 1
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000416 fi
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000417}
418
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000419# Function for waiting for named container to be started manually.
420__wait_for_container() {
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000421 start=$SECONDS
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000422 if [ $# != 2 ]; then
423 echo "Need one arg: <container-name> <instance-id>"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000424 exit 1
425 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000426 http=$(($DFC_PORT+$2))
427 https=$((DFC_PORT_SECURE+$2))
428 echo "The container is expected to map its ports (8100/8433) to the following port visibile on the host: http port ${http} and https port ${https}"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000429 echo "Waiting for container with name '${1}' to be started manually...."
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000430
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000431 for (( ; ; ))
432 do
433 if [ $(docker inspect --format '{{ .State.Running }}' $1 2> /dev/null) ]; then
434 echo "Container running: "$1
435 break
436 else
437 duration=$((SECONDS-start))
438 echo -ne " Waited ${duration} seconds\033[0K\r"
439 sleep 1
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000440 fi
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000441 done
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000442
443 echo "Connecting container "$1" to simulator network "$DOCKER_SIM_NWNAME
444 docker network connect $DOCKER_SIM_NWNAME $1
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000445}
446
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000447#WFunction for waiting for named container to be stopped manually.
448__wait_for_container_gone() {
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000449 start=$SECONDS
450 if [ $# != 1 ]; then
451 echo "Need one arg: <container-name>"
452 exit 1
453 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000454 echo "Disconnecting container "$1" from simulator network "$DOCKER_SIM_NWNAME
455 docker network disconnect $DOCKER_SIM_NWNAME $1
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000456 echo "Waiting for container with name '${1}' to be stopped manually...."
457
458 for (( ; ; ))
459 do
460 if [ $(docker inspect --format '{{ .State.Running }}' $1 2> /dev/null) ]; then
461 duration=$((SECONDS-start))
462 echo -ne " Waited ${duration} seconds\033[0K\r"
463 sleep 1
464 else
465 echo "Container stopped: "$1
466 break
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000467 fi
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000468 done
469}
470
471#Function for waiting to dfc to be started manually
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000472__wait_for_dfc() {
473 http=$(($DFC_PORT+$2))
474 https=$((DFC_PORT_SECURE+$2))
475 echo "The app is expected to listen to http port ${http} and https port ${https}"
476 echo "The app shall use 'localhost' and '8500' for CONSUL_HOST and CONSUL_PORT."
477 echo "The app shale use 'config-binding-service-localhost' for CONFIG_BINDING_SERVICE"
478 echo "The app shall use ${1} for HOSTNAME."
479 read -p "Press enter to continue when app mapping to ${1} has been manually started"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000480}
481
482#Function for waiting to dfc to be stopped manually
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000483__wait_for_dfc_gone() {
484 read -p "Press enter to continue when when app mapping to ${1} has been manually stopped"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000485}
486
487#############################################################
488############## Functions for auto test scripts ##############
489#############################################################
490
491# Print the env variables needed for the simulators and their setup
492log_sim_settings() {
493 echo "Simulator settings"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000494 echo "MR_TC= "$MR_TC
495 echo "MR_GROUPS= "$MR_GROUPS
496 echo "MR_FILE_PREFIX_MAPPING="$MR_FILE_PREFIX_MAPPING
497 echo "DR_TC= "$DR_TC
498 echo "DR_FEEDS= "$DR_FEEDS
499 echo "DR_REDIR_SIM= "$DR_REDIR_SIM
500 echo "DR_REDIR_TC= "$DR_REDIR_TC
501 echo "DR_REDIR_FEEDS= "$DR_REDIR_FEEDS
502
503 echo "NUM_FTPFILES= "$NUM_FTPFILES
504 echo "NUM_PNFS= "$NUM_PNFS
505 echo "FILE_SIZE= "$FILE_SIZE
506 echo "FTP_TYPE= "$FTP_TYPE
507 echo "FTP_FILE_PREFIXES= "$FTP_FILE_PREFIXES
508 echo "NUM_FTP_SERVERS= "$NUM_FTP_SERVERS
509 echo "SFTP_SIMS= "$SFTP_SIMS
510 echo "FTPS_SIMS= "$FTPS_SIMS
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000511 echo ""
512}
513
514# Stop and remove all containers including dfc app and simulators
515clean_containers() {
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000516 echo "Stopping all containers, dfc app(s) and simulators with name prefix 'dfc_'"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000517 docker stop $(docker ps -q --filter name=dfc_) &> /dev/null
518 echo "Removing all containers, dfc app and simulators with name prefix 'dfc_'"
519 docker rm $(docker ps -a -q --filter name=dfc_) &> /dev/null
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000520 echo "Removing unused docker networks with substring 'dfc' in network name"
521 docker network rm $(docker network ls -q --filter name=dfc)
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000522 echo ""
523}
524
525# Start all simulators in the simulator group
526start_simulators() {
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000527
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000528 echo "Starting all simulators"
529 curdir=$PWD
530 cd $SIM_GROUP
531 $SIM_GROUP/simulators-start.sh
532 cd $curdir
533 echo ""
534}
535
536# Start the dfc application
537start_dfc() {
538
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000539 if [ $# != 1 ]; then
540 __print_err "need one arg, <dfc-instance-id>"
541 exit 1
542 fi
543
544 if [ $1 -lt 0 ] || [ $1 -gt $DFC_MAX_IDX ]; then
545 __print_err "arg should be 0.."$DFC_MAX_IDX
546 exit 1
ecaiyanlinux796e8fe2019-08-21 12:10:33 +0000547 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000548 appname=$DFC_APP_BASE$1
549 STARTED_DFCS=$STARTED_DFCS"_"$appname"_"
550
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000551 if [ $START_ARG == "local" ] || [ $START_ARG == "remote" ] || [ $START_ARG == "remote-remove" ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000552 __start_dfc_image $appname $1
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000553 elif [ $START_ARG == "manual-container" ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000554 __wait_for_container $appname $1
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000555 elif [ $START_ARG == "manual-app" ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000556 __wait_for_dfc $appname $1
557 fi
558}
559
maximesson69311bf2019-08-30 14:05:15 +0000560# Configure consul with dfc config, args <dfc-instance-id> <json-file-path>
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000561# Not intended to be called directly by test scripts.
562__consul_config() {
563
maximesson69311bf2019-08-30 14:05:15 +0000564 if [ $# != 2 ]; then
565 __print_err "need two args, <dfc-instance-id> <json-file-path>"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000566 exit 1
567 fi
568
maximesson69311bf2019-08-30 14:05:15 +0000569 if [ $1 -lt 0 ] || [ $1 -gt $DFC_MAX_IDX ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000570 __print_err "dfc-instance-id should be 0.."$DFC_MAX_IDX
571 exit 1
572 fi
maximesson69311bf2019-08-30 14:05:15 +0000573 if ! [ -f $2 ]; then
574 __print_err "json file does not extis: "$2
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000575 exit 1
576 fi
577
maximesson69311bf2019-08-30 14:05:15 +0000578 appname=$DFC_APP_BASE$1
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000579
maximesson69311bf2019-08-30 14:05:15 +0000580 echo "Configuring consul for " $appname " from " $2
581 curl -s http://127.0.0.1:${CONSUL_PORT}/v1/kv/${appname}?dc=dc1 -X PUT -H 'Accept: application/json' -H 'Content-Type: application/json' -H 'X-Requested-With: XMLHttpRequest' --data-binary "@"$2 >/dev/null
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000582}
583
584# Configure consul with dfc app config, args <dfc-instance-id> <json-file-path>
585consul_config_app() {
586 if [ $START_ARG == "manual-app" ]; then
587 echo "Replacing 'mrsim' with 'localhost' in json app config for consul"
588 sed 's/mrsim/localhost/g' $2 > .tmp_app.json
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000589 echo "Replacing 'drsim' with 'localhost' in json dmaap config for consul"
maximesson69311bf2019-08-30 14:05:15 +0000590 sed 's/drsim/localhost/g' .tmp_app.json > .app.json
591 __consul_config $1 .app.json
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000592 else
maximesson69311bf2019-08-30 14:05:15 +0000593 __consul_config $1 $2
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000594 fi
595}
596
597# Stop and remove the dfc app container
598kill_dfc() {
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000599
600 if [ $# != 1 ]; then
601 __print_err "need one arg, <dfc-instance-id>"
602 exit 1
603 fi
604
605 if [ $1 -lt 0 ] || [ $1 -gt $DFC_MAX_IDX ]; then
606 __print_err "arg should be 0.."$DFC_MAX_IDX
607 exit 1
608 fi
609 appname=$DFC_APP_BASE$1
610
611 echo "Killing DFC, instance id: "$1
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000612
613 if [ $START_ARG == "local" ] || [ $START_ARG == "remote" ] || [ $START_ARG == "remote-remove" ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000614 __docker_stop $appname
615 __docker_rm $appname
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000616 elif [ $START_ARG == "manual-container" ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000617 __wait_for_container_gone $appname
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000618 elif [ $START_ARG == "manual-app" ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000619 __wait_for_dfc_gone $appname
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000620 fi
621}
622
623# Stop and remove the DR simulator container
624kill_dr() {
625 echo "Killing DR sim"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000626 __docker_stop dfc_dr-sim
627 __docker_rm dfc_dr-sim
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000628}
629
630# Stop and remove the DR redir simulator container
631kill_drr() {
632 echo "Killing DR redir sim"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000633 __docker_stop dfc_dr-redir-sim
634 __docker_rm dfc_dr-redir-sim
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000635}
636
637# Stop and remove the MR simulator container
638kill_mr() {
639 echo "Killing MR sim"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000640 __docker_stop dfc_mr-sim
641 __docker_rm dfc_mr-sim
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000642}
643
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000644# Stop and remove the SFTP container, arg: <sftp-instance-id>
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000645kill_sftp() {
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000646
647 if [ $# != 1 ]; then
648 __print_err "need one arg, <sftp-instance-id>"
649 exit 1
650 fi
651
652 if [ $1 -lt 0 ] || [ $1 -gt $FTP_MAX_IDX ]; then
653 __print_err "arg should be 0.."$FTP_MAX_IDX
654 exit 1
655 fi
656 appname=$SFTP_BASE$1
657
658 echo "Killing SFTP, instance id: "$1
659
660 __docker_stop $appname
661 __docker_rm $appname
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000662}
663
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000664# Stop SFTP container, arg: <sftp-instance-id>
665stop_sftp() {
666
667 if [ $# != 1 ]; then
668 __print_err "need one arg, <sftp-instance-id>"
669 exit 1
670 fi
671
672 if [ $1 -lt 0 ] || [ $1 -gt $FTP_MAX_IDX ]; then
673 __print_err "arg should be 0.."$FTP_MAX_IDX
674 exit 1
675 fi
676 appname=$SFTP_BASE$1
677
678 echo "Stopping SFTP, instance id: "$1
679
680 __docker_stop $appname
681}
682
683# Starts a stopped SFTP container, arg: <sftp-instance-id>
684start_sftp() {
685
686 if [ $# != 1 ]; then
687 __print_err "need one arg, <sftp-instance-id>"
688 exit 1
689 fi
690
691 if [ $1 -lt 0 ] || [ $1 -gt $FTP_MAX_IDX ]; then
692 __print_err "arg should be 0.."$FTP_MAX_IDX
693 exit 1
694 fi
695 appname=$SFTP_BASE$1
696
697 echo "Starting SFTP, instance id: "$1
698
699 __docker_start $appname
700}
701
702# Stop and remove the FTPS container, arg: <ftps-instance-id>
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000703kill_ftps() {
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000704
705 if [ $# != 1 ]; then
706 __print_err "need one arg, <ftpS-instance-id>"
707 exit 1
708 fi
709
710 if [ $1 -lt 0 ] || [ $1 -gt $FTP_MAX_IDX ]; then
711 __print_err "arg should be 0.."$FTP_MAX_IDX
712 exit 1
713 fi
714 appname=$FTPS_BASE$1
715
716 echo "Killing FTPS, instance id: "$1
717
718 __docker_stop $appname
719 __docker_rm $appname
720}
721
722# Stop FTPS container, arg: <ftps-instance-id>
723stop_ftps() {
724
725 if [ $# != 1 ]; then
726 __print_err "need one arg, <ftps-instance-id>"
727 exit 1
728 fi
729
730 if [ $1 -lt 0 ] || [ $1 -gt $FTP_MAX_IDX ]; then
731 __print_err "arg should be 0.."$FTP_MAX_IDX
732 exit 1
733 fi
734 appname=$FTPS_BASE$1
735
736 echo "Stopping FTPS, instance id: "$1
737
738 __docker_stop $appname
739}
740
741# Starts a stopped FTPS container, arg: <ftps-instance-id>
742start_ftps() {
743
744 if [ $# != 1 ]; then
745 __print_err "need one arg, <ftps-instance-id>"
746 exit 1
747 fi
748
749 if [ $1 -lt 0 ] || [ $1 -gt $FTP_MAX_IDX ]; then
750 __print_err "arg should be 0.."$FTP_MAX_IDX
751 exit 1
752 fi
753 appname=$FTPS_BASE$1
754
755 echo "Starting FTPS, instance id: "$1
756
757 __docker_start $appname
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000758}
759
760# Print a variable value from the MR simulator. Arg: <variable-name>
761mr_print() {
762 if [ $# != 1 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000763 __print_err "need one arg, <sim-param>"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000764 exit 1
765 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000766 echo -e "---- MR sim, \033[1m $1 \033[0m: $(__do_curl http://127.0.0.1:$MR_PORT/$1)"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000767}
768
ecaiyanlinux796e8fe2019-08-21 12:10:33 +0000769# Print a variable value from the MR https simulator. Arg: <variable-name>
770mr_secure_print() {
771 if [ $# != 1 ]; then
772 __print_err "need one arg, <sim-param>"
773 exit 1
774 fi
775 echo -e "---- MR sim, \033[1m $1 \033[0m: $(__do_curl https://127.0.0.1:$MR_PORT_SECURE/$1)"
776}
777
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000778# Print a variable value from the DR simulator. Arg: <variable-name>
779dr_print() {
780 if [ $# != 1 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000781 __print_err "need one arg, <sim-param>"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000782 exit 1
783 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000784 echo -e "---- DR sim, \033[1m $1 \033[0m: $(__do_curl http://127.0.0.1:$DR_PORT/$1)"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000785}
786
787# Print a variable value from the DR redir simulator. Arg: <variable-name>
788drr_print() {
789 if [ $# != 1 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000790 __print_err "need one arg, <sim-param>"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000791 exit 1
792 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000793 echo -e "---- DR redir sim, \033[1m $1 \033[0m: $(__do_curl http://127.0.0.1:$DRR_PORT/$1)"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000794}
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000795# Print a variable value from dfc. Arg: <dfc-instance-id> <variable-name>
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000796dfc_print() {
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000797 if [ $# != 2 ]; then
798 __print_err "need two args, <dfc-instance-id> <dfc-param>"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000799 exit 1
800 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000801 if [ $1 -lt 0 ] || [ $1 -gt $DFC_MAX_IDX ]; then
802 __print_err "dfc instance id should be in range 0.."DFC_MAX_IDX
803 exit 1
804 fi
805 localport=$(($DFC_PORT + $1))
806 appname=$DFC_APP_BASE$1
807 echo -e "---- DFC $appname, \033[1m $2 \033[0m: $(__do_curl http://127.0.0.1:$localport/$2)"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000808}
809
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000810# Read a variable value from MR sim and send to stdout. Arg: <variable-name>
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000811mr_read() {
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000812 echo "$(__do_curl http://127.0.0.1:$MR_PORT/$1)"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000813}
814
ecaiyanlinux796e8fe2019-08-21 12:10:33 +0000815# Read a variable value from MR https sim and send to stdout. Arg: <variable-name>
816mr_secure_read() {
817 echo "$(__do_curl https://127.0.0.1:$MR_PORT_SECURE/$1)"
818}
819
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000820# Read a variable value from DR sim and send to stdout. Arg: <variable-name>
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000821dr_read() {
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000822 echo "$(__do_curl http://127.0.0.1:$DR_PORT/$1)"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000823}
824
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000825# Read a variable value from DR redir sim and send to stdout. Arg: <variable-name>
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000826drr_read() {
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000827 echo "$(__do_curl http://127.0.0.1:$DRR_PORT/$1)"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000828}
829
830
831# Sleep. Arg: <sleep-time-in-sec>
832sleep_wait() {
833 if [ $# != 1 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000834 __print_err "need one arg, <sleep-time-in-sec>"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000835 exit 1
836 fi
837 echo "---- Sleep for " $1 " seconds ----"
838 start=$SECONDS
839 duration=$((SECONDS-start))
840 while [ $duration -lt $1 ]; do
841 echo -ne " Slept for ${duration} seconds\033[0K\r"
842 sleep 1
843 duration=$((SECONDS-start))
844 done
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000845 echo ""
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000846}
847
848# Sleep and print dfc heartbeat. Arg: <sleep-time-in-sec>
849sleep_heartbeat() {
850 if [ $# != 1 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000851 __print_err "need one arg, <sleep-time-in-sec>"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000852 exit 1
853 fi
854 echo "---- Sleep for " $1 " seconds ----"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000855 echo ""
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000856 start=$SECONDS
857 duration=$((SECONDS-start))
858 ctr=0
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000859 rows=0
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000860 while [ $duration -lt $1 ]; do
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000861 if [ $rows -eq 0 ]; then
862 tput cuu1
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000863 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000864 rows=0
865 echo " Slept for ${duration} seconds"
866 if [ $((ctr%30)) -eq 0 ]; then
867 for (( i=0; i<=$DFC_MAX_IDX; i++ )); do
868 if [[ $STARTED_DFCS =~ "_"$DFC_APP_BASE$i"_" ]]; then
869 let rows=rows+1
870 echo " HB ${DFC_APP_BASE}${i}: $(__do_curl http://127.0.0.1:$(($DFC_PORT+$i))/heartbeat)"
871 fi
872 done
873 fi
874
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000875 let ctr=ctr+1
876 sleep 1
877 duration=$((SECONDS-start))
878 done
879 echo ""
880}
881
882# Tests if a variable value in the MR simulator is equal to a target value and and optional timeout.
883# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
884# equal to the target or not.
885# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
886# before setting pass or fail depending on if the variable value becomes equal to the target
887# value or not.
888mr_equal() {
889 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000890 __var_test "MR" "http://127.0.0.1:$MR_PORT/" $1 "=" $2 $3
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000891 else
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000892 __print_err "Wrong args to mr_equal, needs two or three args: <sim-param> <target-value> [ timeout ]"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000893 fi
894}
895
ecaiyanlinux796e8fe2019-08-21 12:10:33 +0000896mr_secure_equal() {
897 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
898 __var_test "MR" "https://127.0.0.1:$MR_PORT_SECURE/" $1 "=" $2 $3
899 else
900 __print_err "Wrong args to mr_secure_equal, needs two or three args: <sim-param> <target-value> [ timeout ]"
901 fi
902}
903
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000904# Tests if a variable value in the MR simulator is greater than a target value and and optional timeout.
905# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
906# greater than the target or not.
907# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
908# before setting pass or fail depending on if the variable value greater than the target
909# value or not.
910mr_greater() {
911 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000912 __var_test "MR" "http://127.0.0.1:$MR_PORT/" $1 ">" $2 $3
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000913 else
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000914 __print_err "Wrong args to mr_greater, needs two or three args: <sim-param> <target-value> [ timeout ]"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000915 fi
916}
917
ecaiyanlinux796e8fe2019-08-21 12:10:33 +0000918mr_secure_greater() {
919 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
920 __var_test "MR" "https://127.0.0.1:$MR_PORT_SECURE/" $1 ">" $2 $3
921 else
922 __print_err "Wrong args to mr_secure_greater, needs two or three args: <sim-param> <target-value> [ timeout ]"
923 fi
924}
925
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000926# Tests if a variable value in the MR simulator is less than a target value and and optional timeout.
927# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
928# less than the target or not.
929# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
930# before setting pass or fail depending on if the variable value less than the target
931# value or not.
932mr_less() {
933 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000934 __var_test "MR" "http://127.0.0.1:$MR_PORT/" $1 "<" $2 $3
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000935 else
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000936 __print_err "Wrong args to mr_less, needs two or three args: <sim-param> <target-value> [ timeout ]"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000937 fi
938}
ecaiyanlinux796e8fe2019-08-21 12:10:33 +0000939mr_secure_less() {
940 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
941 __var_test "MR" "https://127.0.0.1:$MR_PORT_SECURE/" $1 "<" $2 $3
942 else
943 __print_err "Wrong args to mr_secure_less, needs two or three args: <sim-param> <target-value> [ timeout ]"
944 fi
945}
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000946
947# Tests if a variable value in the MR simulator contains the target string and and optional timeout.
948# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable contains
949# the target or not.
950# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
951# before setting pass or fail depending on if the variable value contains the target
952# value or not.
953mr_contain_str() {
954 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000955 __var_test "MR" "http://127.0.0.1:$MR_PORT/" $1 "contain_str" $2 $3
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000956 else
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000957 __print_err "Wrong args to mr_contain_str, needs two or three args: <sim-param> <target-value> [ timeout ]"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000958 fi
959}
ecaiyanlinux796e8fe2019-08-21 12:10:33 +0000960mr_secure_contain_str() {
961 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
962 __var_test "MR" "https://127.0.0.1:$MR_PORT_SECURE/" $1 "contain_str" $2 $3
963 else
964 __print_err "Wrong args to mr_secure_contain_str, needs two or three args: <sim-param> <target-value> [ timeout ]"
965 fi
966}
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000967
968# Tests if a variable value in the DR simulator is equal to a target value and and optional timeout.
969# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
970# equal to the target or not.
971# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
972# before setting pass or fail depending on if the variable value becomes equal to the target
973# value or not.
974dr_equal() {
975 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000976 __var_test "DR" "http://127.0.0.1:$DR_PORT/" $1 "=" $2 $3
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000977 else
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000978 __print_err "Wrong args to dr_equal, needs two or three args: <sim-param> <target-value> [ timeout ]"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000979 fi
980}
981
982# Tests if a variable value in the DR simulator is greater than a target value and and optional timeout.
983# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
984# greater than the target or not.
985# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
986# before setting pass or fail depending on if the variable value greater than the target
987# value or not.
988dr_greater() {
989 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000990 __var_test "DR" "http://127.0.0.1:$DR_PORT/" $1 ">" $2 $3
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000991 else
BjornMagnussonXAa79a0432019-07-17 08:26:50 +0000992 __print_err "Wrong args to dr_greater, needs two or three args: <sim-param> <target-value> [ timeout ]"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +0000993 fi
994}
995
996# Tests if a variable value in the DR simulator is less than a target value and and optional timeout.
997# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
998# less than the target or not.
999# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
1000# before setting pass or fail depending on if the variable value less than the target
1001# value or not.
1002dr_less() {
1003 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001004 __var_test "DR" "http://127.0.0.1:$DR_PORT/" $1 "<" $2 $3
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001005 else
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001006 __print_err "Wrong args to dr_less, needs two or three args: <sim-param> <target-value> [ timeout ]"
1007 fi
1008}
1009
1010# Tests if a variable value in the DR simulator contains the target string and and optional timeout.
1011# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable contains
1012# the target or not.
1013# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
1014# before setting pass or fail depending on if the variable value contains the target
1015# value or not.
1016dr_contain_str() {
1017 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
1018 __var_test "DR" "http://127.0.0.1:$DR_PORT/" $1 "contain_str" $2 $3
1019 else
1020 __print_err "Wrong args to dr_contain_str, needs two or three args: <sim-param> <target-value> [ timeout ]"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001021 fi
1022}
1023
1024# Tests if a variable value in the DR Redir simulator is equal to a target value and and optional timeout.
1025# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
1026# equal to the target or not.
1027# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
1028# before setting pass or fail depending on if the variable value becomes equal to the target
1029# value or not.
1030drr_equal() {
1031 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001032 __var_test "DR REDIR" "http://127.0.0.1:$DRR_PORT/" $1 "=" $2 $3
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001033 else
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001034 __print_err "Wrong args to drr_equal, needs two or three args: <sim-param> <target-value> [ timeout ]"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001035 fi
1036}
1037
1038
1039# Tests if a variable value in the DR Redir simulator is greater a target value and and optional timeout.
1040# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
1041# greater the target or not.
1042# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
1043# before setting pass or fail depending on if the variable value greater than the target
1044# value or not.
1045drr_greater() {
1046 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001047 __var_test "DR REDIR" "http://127.0.0.1:$DRR_PORT/" $1 ">" $2 $3
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001048 else
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001049 __print_err "Wrong args to drr_greater, needs two or three args: <sim-param> <target-value> [ timeout ]"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001050 fi
1051}
1052
1053# Tests if a variable value in the DR Redir simulator is less than a target value and and optional timeout.
1054# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
1055# less than the target or not.
1056# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
1057# before setting pass or fail depending on if the variable value less than the target
1058# value or not.
1059drr_less() {
1060 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001061 __var_test "DR REDIR" "http://127.0.0.1:$DRR_PORT/" $1 "<" $2 $3
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001062 else
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001063 __print_err "Wrong args to drr_less, needs two or three args: <sim-param> <target-value> [ timeout ]"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001064 fi
1065}
1066
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001067# Tests if a variable value in the DR redir simulator contains the target string and and optional timeout.
1068# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable contains
1069# the target or not.
1070# Arg: <variable-name> <target-value> <timeout-in-sec> - This test waits up to the timeout seconds
1071# before setting pass or fail depending on if the variable value contains the target
1072# value or not.
1073drr_contain_str() {
1074 if [ $# -eq 2 ] || [ $# -eq 3 ]; then
1075 __var_test "DR REDIR" "http://127.0.0.1:$DRR_PORT/" $1 "contain_str" $2 $3
1076 else
1077 __print_err "Wrong args to drr_contain_str, needs two or three args: <sim-param> <target-value> [ timeout ]"
1078 fi
1079}
1080
1081#Test if a variable in the DFC contains a substring. Arg: <dfc-index> <variable-name> <substring-in-quotes>
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001082dfc_contain_str() {
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001083 if [ $# -eq 3 ]; then
1084 if [ $1 -lt 0 ] || [ $1 -gt $DFC_MAX_IDX ]; then
1085 __print_err "arg should be 0.."$DFC_MAX_IDX
1086 exit 1
1087 fi
1088 appname=$DFC_APP_BASE$1
1089 localport=$(($DFC_PORT + $1))
1090 echo -e "---- DFC test criteria: $appname \033[1m ${2} \033[0m contains: ${3} ----"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001091 ((RES_TEST++))
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001092 result="$(__do_curl http://127.0.0.1:$localport/${2})"
1093 if [[ $result =~ $3 ]]; then
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001094 ((RES_PASS++))
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001095 echo -e "---- \033[32m\033[1mPASS\033[0m - Test criteria met"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001096 else
1097 ((RES_FAIL++))
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001098 echo -e "---- \033[31m\033[1mFAIL\033[0m - Target '${3}' not reached, result = ${result} ----"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001099 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001100 else
1101 echo "Wrong args to dfc_contain_str, needs three arg: <dfc-index> <dfc-variable> <str>"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001102 exit 1
1103 fi
1104}
1105
1106# Store all dfc app and simulators log to the test case log dir. All logs gets a prefix to
1107# separate logs stored at different steps in the test script. Arg: <tc-id> <log-prefix>
1108store_logs() {
1109 if [ $# != 1 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001110 __print_err "need one arg, <file-prefix>"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001111 exit 1
1112 fi
1113 echo "Storing all container logs and dfc app log using prefix: "$1
1114 if ! [ $START_ARG == "manual-app" ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001115 for (( i=0; i<=$DFC_MAX_IDX; i++ )); do
1116 appname=$DFC_APP_BASE$i
1117 tmp=$(docker ps | grep $appname)
1118 if ! [ -z "$tmp" ]; then #Only stored logs from running DFC apps
1119 docker cp $appname:/var/log/ONAP/application.log $TESTLOGS/$ATC/${1}_${appname}_application.log
1120 docker logs $appname > $TESTLOGS/$ATC/$1_$appname-docker.log 2>&1
1121 fi
1122 done
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001123 fi
1124 docker logs dfc_mr-sim > $TESTLOGS/$ATC/$1_dfc_mr-sim-docker.log 2>&1
1125 docker logs dfc_dr-sim > $TESTLOGS/$ATC/$1_dfc_dr-sim-docker.log 2>&1
1126 docker logs dfc_dr-redir-sim > $TESTLOGS/$ATC/$1_dfc_dr-redir-sim-docker.log 2>&1
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001127
1128 for (( i=0; i<=$FTP_MAX_IDX; i++ )); do
1129 appname=$SFTP_BASE$i
1130 docker logs $appname > $TESTLOGS/$ATC/${1}_${appname}.log 2>&1
1131 appname=$FTPS_BASE$i
1132 docker logs $appname > $TESTLOGS/$ATC/${1}_${appname}.log 2>&1
1133 done
1134
1135 docker logs dfc_consul > $TESTLOGS/$ATC/$1_consul.log 2>&1
1136 docker logs dfc_cbs > $TESTLOGS/$ATC/$1_cbs.log 2>&1
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001137}
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001138# Check the dfc application log, for all dfc instances, for WARN and ERR messages and print the count.
1139check_dfc_logs() {
1140 for (( i=0; i<=$DFC_MAX_IDX; i++ )); do
1141 appname=$DFC_APP_BASE$i
1142 tmp=$(docker ps | grep $appname)
1143 if ! [ -z "$tmp" ]; then #Only check logs for running dfc_apps
1144 _check_dfc_log $appname
1145 fi
1146 done
1147}
1148
1149# Check dfc app log for one dfc instance, arg <dfc-app-name>
1150_check_dfc_log() {
1151 echo "Checking $1 log $DFC_LOGPATH for WARNINGs and ERRORs"
1152 foundentries=$(docker exec -it $1 grep WARN /var/log/ONAP/application.log | wc -l)
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001153 if [ $? -ne 0 ];then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001154 echo " Problem to search $1 log $DFC_LOGPATH"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001155 else
1156 if [ $foundentries -eq 0 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001157 echo " No WARN entries found in $1 log $DFC_LOGPATH"
1158 else
1159 echo -e " Found \033[1m"$foundentries"\033[0m WARN entries in $1 log $DFC_LOGPATH"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001160 fi
1161 fi
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001162 foundentries=$(docker exec -it $1 grep ERR $DFC_LOGPATH | wc -l)
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001163 if [ $? -ne 0 ];then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001164 echo " Problem to search $1 log $DFC_LOGPATH"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001165 else
1166 if [ $foundentries -eq 0 ]; then
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001167 echo " No ERR entries found in $1 log $DFC_LOGPATH"
1168 else
1169 echo -e " Found \033[1m"$foundentries"\033[0m ERR entries in $1 log $DFC_LOGPATH"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001170 fi
1171 fi
1172}
1173
1174print_all() {
1175
1176 echo "---- DFC and all sim variables"
1177
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001178 for (( i=0; i<=$DFC_MAX_IDX; i++ )); do
1179 appname=$DFC_APP_BASE$i
1180 tmp=$(docker ps | grep $appname)
1181 if ! [ -z "$tmp" ]; then #Only check running dfc_apps
1182 dfc_print $i status
1183 fi
1184 done
1185
1186
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001187 mr_print tc_info
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001188 mr_print status
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001189 mr_print execution_time
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001190 mr_print groups
1191 mr_print changeids
1192 mr_print fileprefixes
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001193 mr_print exe_time_first_poll
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001194 mr_print groups/exe_time_first_poll
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001195 mr_print ctr_requests
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001196 mr_print groups/ctr_requests
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001197 mr_print ctr_responses
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001198 mr_print groups/ctr_responses
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001199 mr_print ctr_files
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001200 mr_print groups/ctr_files
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001201 mr_print ctr_unique_files
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001202 mr_print groups/ctr_unique_files
1203 mr_print groups/ctr_events
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001204 mr_print ctr_events
1205 mr_print ctr_unique_PNFs
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001206 mr_print groups/ctr_unique_PNFs
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001207
1208 dr_print tc_info
1209 dr_print execution_time
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001210 dr_print feeds
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001211 dr_print ctr_publish_query
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001212 dr_print feeds/ctr_publish_query
1213 dr_print ctr_publish_query_bad_file_prefix
1214 dr_print feeds/ctr_publish_query_bad_file_prefix
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001215 dr_print ctr_publish_query_published
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001216 dr_print feeds/ctr_publish_query_published
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001217 dr_print ctr_publish_query_not_published
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001218 dr_print feeds/ctr_publish_query_not_published
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001219 dr_print ctr_publish_req
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001220 dr_print feeds/ctr_publish_req
1221 dr_print ctr_publish_req_bad_file_prefix
1222 dr_print feeds/ctr_publish_req_bad_file_prefix
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001223 dr_print ctr_publish_req_redirect
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001224 dr_print feeds/ctr_publish_req_redirect
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001225 dr_print ctr_publish_req_published
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001226 dr_print feeds/ctr_publish_req_published
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001227 dr_print ctr_published_files
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001228 dr_print feeds/ctr_published_files
1229 dr_print ctr_double_publish
1230 dr_print feeds/ctr_double_publish
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001231
1232 drr_print tc_info
1233 drr_print execution_time
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001234 drr_print feeds
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001235 drr_print ctr_publish_requests
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001236 drr_print feeds/ctr_publish_requests
1237 drr_print ctr_publish_requests_bad_file_prefix
1238 drr_print feeds/ctr_publish_requests_bad_file_prefix
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001239 drr_print ctr_publish_responses
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001240 drr_print feeds/ctr_publish_responses
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001241 drr_print dwl_volume
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001242 drr_print feeds/dwl_volume
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001243 drr_print time_lastpublish
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001244 drr_print feeds/time_lastpublish
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001245}
1246
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001247# Print the test result
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001248print_result() {
1249
1250 TCTEST_END=$SECONDS
1251 duration=$((TCTEST_END-TCTEST_START))
1252
1253 echo "-------------------------------------------------------------------------------------------------"
1254 echo "------------------------------------- Test case: "$ATC
1255 echo "------------------------------------- Ended: "$(date)
1256 echo "-------------------------------------------------------------------------------------------------"
1257 echo "-- Description: "$TC_ONELINE_DESCR
1258 echo "-- Execution time: " $duration " seconds"
1259 echo "-------------------------------------------------------------------------------------------------"
1260 echo "------------------------------------- RESULTS"
1261 echo ""
1262
1263
1264 total=$((RES_PASS+RES_FAIL))
1265 if [ $RES_TEST -eq 0 ]; then
1266 echo -e "\033[1mNo tests seem to have executed. Check the script....\033[0m"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001267 echo -e "\033[31m\033[1m ___ ___ ___ ___ ___ _____ ___ _ ___ _ _ _ ___ ___ \033[0m"
1268 echo -e "\033[31m\033[1m/ __|/ __| _ \_ _| _ \_ _| | __/_\ |_ _| | | | | | _ \ __|\033[0m"
1269 echo -e "\033[31m\033[1m\__ \ (__| /| || _/ | | | _/ _ \ | || |_| |_| | / _| \033[0m"
1270 echo -e "\033[31m\033[1m|___/\___|_|_\___|_| |_| |_/_/ \_\___|____\___/|_|_\___|\033[0m"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001271 elif [ $total != $RES_TEST ]; then
1272 echo -e "\033[1mTotal number of tests does not match the sum of passed and failed tests. Check the script....\033[0m"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001273 echo -e "\033[31m\033[1m ___ ___ ___ ___ ___ _____ ___ _ ___ _ _ _ ___ ___ \033[0m"
1274 echo -e "\033[31m\033[1m/ __|/ __| _ \_ _| _ \_ _| | __/_\ |_ _| | | | | | _ \ __|\033[0m"
1275 echo -e "\033[31m\033[1m\__ \ (__| /| || _/ | | | _/ _ \ | || |_| |_| | / _| \033[0m"
1276 echo -e "\033[31m\033[1m|___/\___|_|_\___|_| |_| |_/_/ \_\___|____\___/|_|_\___|\033[0m"
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001277 elif [ $RES_PASS = $RES_TEST ]; then
1278 echo -e "All tests \033[32m\033[1mPASS\033[0m"
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001279 echo -e "\033[32m\033[1m ___ _ ___ ___ \033[0m"
1280 echo -e "\033[32m\033[1m | _ \/_\ / __/ __| \033[0m"
1281 echo -e "\033[32m\033[1m | _/ _ \\__ \__ \\ \033[0m"
1282 echo -e "\033[32m\033[1m |_|/_/ \_\___/___/ \033[0m"
1283 echo ""
1284
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001285 # Update test suite counter
1286 if [ -f .tmp_tcsuite_pass_ctr ]; then
1287 tmpval=$(< .tmp_tcsuite_pass_ctr)
1288 ((tmpval++))
1289 echo $tmpval > .tmp_tcsuite_pass_ctr
1290 fi
1291 if [ -f .tmp_tcsuite_pass ]; then
1292 echo " - "$ATC " -- "$TC_ONELINE_DESCR" Execution time: "$duration" seconds" >> .tmp_tcsuite_pass
1293 fi
1294 else
1295 echo -e "One or more tests with status \033[31m\033[1mFAIL\033[0m "
BjornMagnussonXAa79a0432019-07-17 08:26:50 +00001296 echo -e "\033[31m\033[1m ___ _ ___ _ \033[0m"
1297 echo -e "\033[31m\033[1m | __/_\ |_ _| | \033[0m"
1298 echo -e "\033[31m\033[1m | _/ _ \ | || |__ \033[0m"
1299 echo -e "\033[31m\033[1m |_/_/ \_\___|____|\033[0m"
1300 echo ""
BjornMagnussonXA42dcb262019-04-26 19:29:54 +00001301 # Update test suite counter
1302 if [ -f .tmp_tcsuite_fail_ctr ]; then
1303 tmpval=$(< .tmp_tcsuite_fail_ctr)
1304 ((tmpval++))
1305 echo $tmpval > .tmp_tcsuite_fail_ctr
1306 fi
1307 if [ -f .tmp_tcsuite_fail ]; then
1308 echo " - "$ATC " -- "$TC_ONELINE_DESCR" Execution time: "$duration" seconds" >> .tmp_tcsuite_fail
1309 fi
1310 fi
1311
1312 echo "++++ Number of tests: "$RES_TEST
1313 echo "++++ Number of passed tests: "$RES_PASS
1314 echo "++++ Number of failed tests: "$RES_FAIL
1315 echo "------------------------------------- Test case complete ---------------------------------"
1316 echo "-------------------------------------------------------------------------------------------------"
1317 echo ""
1318}